@ECHO OFF
REM This script updates and builds the Windows SDK
REM Before moving to a new version this script must be updated.
REM When properly configured this script does:
REM
REM 1. Update the source and project directories in SNFMultiSDK_Windows_X.Y
REM    from the same directories in ../SNFMultiSDK_Windows_X.Y
REM
REM 2. Copy SNFMultiSDK_Windows_X.Y to SDKBuild/SNFMultiSDK_Windows_X.Y
REM
REM 3. Remove the .svn files from all subdirectories in Build/SNFMultiSDK_Windows_X.Y
REM
REM 4. Create the zip file SNFMultiSDK_Windows_X.Y.zip
REM
REM 5. Copy the SNFMultiSDK_Windows_X.Y.zip file to .. (back to the PKG-SNF-SDK-WIN root)
REM
REM 6. Empty the SDKBuild directory.
REM
REM 7. Pause to let the developer view the success and remind them to commit the revision to SVN.

setlocal
set PATH=32bitdll;%PATH%
set DISTDIR=SNFMultiSDK_Windows_3.2
set TEMPDIR=C:\TEMP
set ZIPFILE=%DISTDIR%.zip
set TEMPDIST=%TEMPDIR%\%DISTDIR%

BuildDistribution\BuildDistribution -d %DISTDIR% -t %TEMPDIR%

@DEL %ZIPFILE%
jzip -p -r %ZIPFILE% %TEMPDIST%
ECHO Created zipfile %ZIPFILE%

RMDIR /S /Q %TEMPDIST%
